#lang racket

; typical example
#;(define (fact n)
    (if ( = 0 n) 1
        (* n (fact (- n 1)))))

; memoize version
(define fact
  (let ([h (make-hash)]) ; hash table to contain memoized values
    (define (fact n)
      (cond [(= n 0) 1]
            [(hash-has-key? h n) (hash-ref h n)]
            [else
             (let ([f (* n (fact (- n 1)))])
               (hash-set! h n f)
               f)]))
    fact))
